/////////////////////////////////////////////////////////////////////////////
//
// Last update	$Date: 2009/12/20 12:03:28 $ UTC
//   Revision   $Revision: 1.14 $
//
//	Modified by Claybird <claybird.without.wing@gmail.com>
//
// registry.cpp :	WXgւ̓o^ƍ폜̒`
//					LhaForgegj[
//
//	Original File Information:
// registry.cpp :	WXgւ̓o^ƍ폜̒`
//					l(TF)gj[
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "registry.h"
#include "main.h"
#include "resource.h"

const int CLSID_STRING_SIZE=(39+1);

extern	HINSTANCE	g_hInstDLL;

// VFGNXeVo^gqꗗ
static const TCHAR *g_ExtList[] =
{
	_T("*"),	//ׂẴt@C
	_T("Directory"),//tH_
	_T("Drive"),	//hCu
	NULL
};

//vg^Cv錾
void WINAPI CLSIDtoString(REFCLSID, CString&);
BOOL WINAPI SetKeyAndValue(HKEY, LPCTSTR, LPCTSTR, LPCTSTR);
LONG RecursiveDeleteKey(HKEY, LPCTSTR);
BOOL DeleteNamedValue(HKEY, LPCTSTR, LPCTSTR);

//-----------

STDAPI RegisterServer(HMODULE hModule,REFCLSID clsid,bool bDrag)
{
	TCHAR szDllPath[_MAX_PATH+1];
	CString strCLSID;
	CString	strKey;

	// o^pDLL̃tpX擾B
	GetModuleFileName(hModule, szDllPath, _MAX_PATH);

	// nꂽNXIDAWXgL[쐬B
	//   "CLSID\xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"
	CLSIDtoString(clsid, strCLSID);
	strKey.Format(_T("CLSID\\%s"), strCLSID);

	//WXgɓo^AvP[V
#ifndef WIN64
	const LPCTSTR szAppName=_T("LhaForge");
#else
	const LPCTSTR szAppName=_T("LhaForge64");
#endif// WIN64

	// CLSIDƃR|[lgo^B
	SetKeyAndValue(HKEY_CLASSES_ROOT, strKey, NULL, szAppName);

	// sW[o^B
	strKey+=_T("\\InprocServer32");
	SetKeyAndValue(HKEY_CLASSES_ROOT, strKey, NULL, szDllPath);
	SetKeyAndValue(HKEY_CLASSES_ROOT, strKey, _T("ThreadingModel"), _T("Apartment"));

	if(bDrag){
		//----------------------------------
		// EhbOj[nh̓o^
		//----------------------------------
		// Folder  hbO&hbvnh Ƃēo^
		CString strDnDHandlerKey;
		strDnDHandlerKey.Format(_T("Folder\\shellex\\DragDropHandlers\\%s"), szAppName);
		SetKeyAndValue(HKEY_CLASSES_ROOT,strDnDHandlerKey,NULL,strCLSID);
		// Drive  hbO&hbvnh Ƃēo^
		strDnDHandlerKey.Format(_T("Drive\\shellex\\DragDropHandlers\\%s"), szAppName);
		SetKeyAndValue(HKEY_CLASSES_ROOT,strDnDHandlerKey,NULL,strCLSID);
	}else{
		//----------------------------------
		// ENbNj[nh̓o^
		//----------------------------------
		// egqContextMenuHandlersnho^B
		for(int i = 0; g_ExtList[i]; i++){
			strKey.Format(_T("%s\\shellex\\ContextMenuHandlers\\%s"),g_ExtList[i],szAppName);
			SetKeyAndValue(HKEY_CLASSES_ROOT,strKey,NULL,strCLSID);
		}
	}


	// NT/2000p̏o^邪Aɂ́AAdministratorKvB
	// sꍇ́AB
	SetKeyAndValue(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved"),strCLSID,szAppName);

	return S_OK;
}


STDAPI UnregisterServer(REFCLSID clsid,bool bDrag)
{
	CString strCLSID;
	CString	strKey;

	// nꂽNXIDAWXgL[쐬B
	//   "CLSID\xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"
	CLSIDtoString(clsid, strCLSID);
	strKey.Format(_T("CLSID\\%s"), strCLSID);

	// "HKEY_CLASSES_ROOT\CLSID"ANXID̃Gg폜B
	RecursiveDeleteKey(HKEY_CLASSES_ROOT, strKey);


	//WXgɓo^AvP[V
#ifndef WIN64
	const LPCTSTR szAppName=_T("LhaForge");
#else
	const LPCTSTR szAppName=_T("LhaForge64");
#endif// WIN64

	if(bDrag){
		//----------------------------------
		// EhbOj[nh̉
		//----------------------------------
		// Folder  hbO&hbvnh 
		CString strDnDHandlerKey;
		strDnDHandlerKey.Format(_T("Folder\\shellex\\DragDropHandlers\\%s"), szAppName);
		RecursiveDeleteKey(HKEY_CLASSES_ROOT,strDnDHandlerKey);
		// Drive  hbO&hbvnh 
		strDnDHandlerKey.Format(_T("Drive\\shellex\\DragDropHandlers\\%s"), szAppName);
		RecursiveDeleteKey(HKEY_CLASSES_ROOT,strDnDHandlerKey);
	}else{
		//----------------------------------
		// ENbNj[nh̉
		//----------------------------------
		// egqContextMenuHandlersnh̓o^B
		for(int i = 0; g_ExtList[i]; i++){
			strKey.Format(_T("%s\\shellex\\ContextMenuHandlers\\%s"),g_ExtList[i],szAppName);
			RecursiveDeleteKey(HKEY_CLASSES_ROOT,strKey);
		}
	}

	// NT/2000p̏폜Bɂ́AAdministratorKvB
	DeleteNamedValue(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved"),strCLSID);

	return S_OK ;
}


// CLSID𕶎ɕϊB
static void WINAPI CLSIDtoString(REFCLSID clsid,CString &strCLSID)
{
	WCHAR theCLSID[CLSID_STRING_SIZE+1];

	// NXID𕶎ɕϊB
	StringFromGUID2(clsid, theCLSID, CLSID_STRING_SIZE);
	strCLSID=theCLSID;
	dprintf(_T("CLSID=%s\n"),(LPCTSTR)strCLSID);
}


static BOOL WINAPI SetKeyAndValue(HKEY inKeyRootH,LPCTSTR inKey,LPCTSTR inValueName,LPCTSTR inValue)
{
	HKEY theKeyH;
	long result;

	// 쐬L[ŃL[쐬or擾B
	result = RegCreateKeyEx(inKeyRootH,
							 inKey,
							 0,
							 NULL,
							 REG_OPTION_NON_VOLATILE,
							 KEY_ALL_ACCESS,
							 NULL,
							 &theKeyH,
							 NULL);
	if(result != ERROR_SUCCESS){
		return FALSE;
	}

	// lݒ肷B
	if(inValue != NULL){
		RegSetValueEx(theKeyH,
					  inValueName,
					  0,
					  REG_SZ,
					  (BYTE *)inValue,
					  (DWORD)(_tcslen(inValue)+1)*sizeof(TCHAR));
	}
	RegCloseKey(theKeyH);
	return TRUE;
}


// ċNIWXg폜
static LONG RecursiveDeleteKey(HKEY inKeyParentH,LPCTSTR inKeyChild)
{
	HKEY theKeyChildH;
	long theRes;
	FILETIME theTime;
	TCHAR theBuffer[256];
	DWORD theSize;

	// Open the child.
	theRes = RegOpenKeyEx(inKeyParentH, inKeyChild, 0, KEY_ALL_ACCESS, &theKeyChildH);
	if(theRes != ERROR_SUCCESS){
		return theRes;
	}

	// Enumerate all of the decendents of this child.
	theSize = 256;
	while(RegEnumKeyEx(theKeyChildH, 0, theBuffer, &theSize, NULL, NULL, NULL, &theTime) == S_OK){
		// Delete the decendents of this child.
		theRes = RecursiveDeleteKey(theKeyChildH, theBuffer);
		if(theRes != ERROR_SUCCESS){
			// Cleanup before exiting.
			RegCloseKey(theKeyChildH);
			return theRes;
		}
		theSize = 256;
	}

	// Close the child.
	RegCloseKey(theKeyChildH);

	// Delete this child.
	return RegDeleteKey(inKeyParentH, inKeyChild);
}


// Otl̍폜
static BOOL DeleteNamedValue(HKEY inKeyRootH,LPCTSTR inSubKey,LPCTSTR inValueName)
{
	HKEY theKeyH;
	long result;
	DWORD theDisposition;

	result = RegCreateKeyEx(inKeyRootH,
							 inSubKey,
							 0,
							 NULL,
							 REG_OPTION_NON_VOLATILE,
							 KEY_ALL_ACCESS,
							 NULL,
							 &theKeyH,
							 &theDisposition);
	if(result != ERROR_SUCCESS){
		return FALSE;
	}

	if(theDisposition == REG_CREATED_NEW_KEY){
		// VL[쐬Ă܂ꍇ́A
		// ̃L[폜āAIB
		RegCloseKey(theKeyH);
		RegDeleteKey(inKeyRootH, inSubKey);
		return FALSE;
	}

	// Otl̍폜B
	RegDeleteValue(theKeyH, inValueName);
	RegCloseKey(theKeyH);
	return TRUE;
}
